/*
   This test program runs your solutions to the recurrence relation,
   The time it takes is (roughly) calculated.
*/
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>   // needed for LARGE_INTEGER  and QueryPerformanceCounter()
#include "Timing.h"
#include "Recursion.h"
#include "BottomUp.h"
#include "TopDown.h"

int main(int argc, char** argv)
{
   LARGE_INTEGER timeStart, timeEnd;             // time in clock-ticks
   LARGE_INTEGER clockFrequency;                 // clock-ticks per second
   double elapsedTicks;
   TimingObject startTime, endTime, elapsedTime; // time in milli-seconds
   double C;
   int i, counter = 0;
   int n;
   if (argc > 1)
   {
      n = atoi( argv[1] );  // get parameter from command line
   }
   else
   {
      printf("Usage: Main <n>");
      return 0;
   }

   // get number of clock ticks per second
   QueryPerformanceFrequency(&clockFrequency);

   // Compute the recurrence relation.
   getThreadTime( &startTime );           // milli-second timer
   QueryPerformanceCounter( &timeStart ); // clock-tick timer
   for (i = 0; i <= n; i++)
   {
      C = C_recursion( i );
      //C = C_bottom_up( i );
      //C = C_top_down( i );
      printf("C[%d] = %f\n", i, C);
   }
   QueryPerformanceCounter( &timeEnd );
   getThreadTime( &endTime );

   // Compute the elapsed time.
   elapsedTicks = timeEnd.QuadPart - timeStart.QuadPart;
   computeElapsedTime( &startTime, &endTime, &elapsedTime );

   printf("Which took\n");
   printf("\t%f seconds,\n", elapsedTicks/clockFrequency.QuadPart);
   printTimingObject( &elapsedTime );
   printf("to compute.\n");

   return 0;
}//main()
